export declare type State<T> = {
    path: string[];
    root: string[];
    data: Record<string, ColumnItem<T>>;
};
export declare type Action<T> = {
    type: "insert";
    item: T;
    parentId?: string;
} | {
    type: "push" | "pop";
    item: string;
    section?: number;
};
export declare type ColumnItem<T> = {
    id: string;
    parentId?: string;
    children: string[];
    data: T;
};
export declare type UseColumnViewHookOptions<T> = {
    path?: string[];
    fetchData?: Function;
    initialValues?: T[];
};
export interface UseColumnViewHookResult<T> {
    root: CreateItemsPropsResult<T>;
    path: CreateItemsPropsResult<T>;
    insert: (item: T, parentId?: string) => void;
}
export declare type MapCallback<T> = (item: WrappedItem<T>, index: number, original: string[]) => any | void;
export declare type CreateItemsPropsResult<T> = {
    original: string[];
    map: (callback: MapCallback<T>) => CreateItemsPropsResult<T>[];
    forEach: (callback: MapCallback<T>) => void;
    includes: (item: any) => boolean;
    length: number;
};
export declare type WrappedItem<TInstance extends {}> = TInstance & {
    isSelected?: boolean;
    pushAt: (section: number) => void;
    children: () => CreateItemsPropsResult<TInstance>;
    buildProps: (additional?: object) => {
        key: string;
    };
};
